%define commit0                ad9bc4600ce769a8b3ad10910803cd555811b70c

%define libname_major          1
%define libname_core_major     1
### Qt4 libraries
%define libname                %mklibname %name %libname_major
%define libname_core           %mklibname qtsinglecoreapplication %libname_core_major
%define libname_devel          %mklibname %name -d
%define libname_core_devel     %mklibname qtsinglecoreapplication -d
### Qt5 libraries
%define libname_qt5            %mklibname %name-qt5_ %libname_major
%define libname_core_qt5       %mklibname qtsinglecoreapplication-qt5_ %libname_core_major
%define libname_devel_qt5      %mklibname %name-qt5 -d
%define libname_core_devel_qt5 %mklibname qtsinglecoreapplication-qt5 -d

Summary:        Qt library to start applications only once per user
Name:           qtsingleapplication
Version:        2.6.1
Release:        %mkrel 2
Group:          System/Libraries
License:        GPLv3 or LGPLv2 with exceptions
URL:            http://doc.qt.digia.com/solutions/4/qtsingleapplication/qtsingleapplication.html
Source0:        https://github.com/qtproject/qt-solutions/archive/%{commit0}.tar.gz#/%{name}-%{commit0}.tar.xz
# Proposed upstream in https://codereview.qt-project.org/#/c/92417/
Source1:        qtsingleapplication.prf
# Proposed upstream in https://codereview.qt-project.org/#/c/92416/
Source2:        qtsinglecoreapplication.prf
# Proposed upstream in https://codereview.qt-project.org/#/c/92411/
Source3:        LGPL_EXCEPTION
# Proposed upstream in https://codereview.qt-project.org/#/c/92416/
Patch0:         qtsingleapplication-2.6.1-fda-build-qtsinglecoreapplication.patch
# Proposed upstream in https://codereview.qt-project.org/#/c/92415/
Patch1:         qtsingleapplication-2.6.1-fda-remove-included-qtlockedfile.patch
# Features for unbundling in Qupzilla, https://github.com/QupZilla/qupzilla/issues/1503
Patch2:         qtsingleapplication-2.6.1-fda-qupzilla.patch

BuildRequires: %{_lib}qt4-devel
BuildRequires: %{_lib}qt4lockedfile-devel

BuildRequires: %{_lib}qt5core-devel
BuildRequires: %{_lib}qt5network-devel
BuildRequires: %{_lib}qt5widgets-devel
BuildRequires: %{_lib}qt5lockedfile-devel

%description
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a running
instance, and to send command strings to that instance.

# ----------------------------

%package -n     %libname
Summary:        Qt library to start applications only once per user
Group:          System/Libraries
Requires:       qt4-common

%description -n %libname
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a running
instance, and to send command strings to that instance.

This is the library package for QtSingleApplication.

%files -n %libname
%doc README.TXT licenses/LGPL_EXCEPTION
%{_qt4_libdir}/lib*QtSolutions_SingleApplication*.so.%{libname_major}*
%{_qt4_libdir}/lib*QtSolutions_SingleCoreApplication*.so.%{libname_core_major}*
# ----------------------------

%package -n     %libname_devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{libname} = %{version}-%{release}
Provides:       qtsingleapplication-devel = %{version}-%{release}

%description -n %libname_devel
This package contains libraries and header files for developing applications
that use QtSingleApplication.

%files -n %libname_devel
%doc doc/html/ examples/
%{_qt4_libdir}/libQtSolutions_SingleApplication*.so
%dir %{_qt4_includedir}/QtSolutions/
%{_qt4_includedir}/QtSolutions/QtSingleApplication
%{_qt4_includedir}/QtSolutions/%{name}.h
%{_qt4_datadir}/mkspecs/features/qtsingleapplication.prf
%{_qt4_libdir}/lib*QtSolutions_SingleCoreApplication*.so
%dir %{_qt4_includedir}/QtSolutions/
%{_qt4_includedir}/QtSolutions/QtSingleCoreApplication
%{_qt4_includedir}/QtSolutions/qtsinglecoreapplication.h
%{_qt4_datadir}/mkspecs/features/qtsinglecoreapplication.prf

# ----------------------------
### Qt5 ###

%package -n     %libname_qt5
Summary:        Qt5 library to start applications only once per user
Group:          System/Libraries
Requires:       qtbase5-common

%description -n %libname_qt5
For some applications it is useful or even critical that they are started
only once by any user. Future attempts to start the application should
activate any already running instance, and possibly perform requested
actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a running
instance, and to send command strings to that instance.

This is the library package for QtSingleApplication.

This is a special build against Qt5.

%files -n %libname_qt5
%doc README.TXT licenses/LGPL_EXCEPTION
%{_qt5_libdir}/lib*Qt5Solutions_SingleApplication*.so.%{libname_major}*
%{_qt5_libdir}/lib*Qt5Solutions_SingleCoreApplication*.so.%{libname_core_major}*

# ----------------------------

%package -n     %libname_devel_qt5
Summary:        Development files for %{name}-qt5
Group:          Development/Libraries
Requires:       %{libname_qt5} = %{version}-%{release}
Provides:       qtsingleapplication-qt5-devel = %{version}-%{release}

%description -n %libname_devel_qt5
This package contains libraries and header files for developing applications
that use QtSingleApplication with Qt5.

%files -n %libname_devel_qt5
%doc doc/html/ examples/
%{_qt5_libdir}/lib*Qt5Solutions_SingleApplication*.so
%dir %{_qt5_includedir}/QtSolutions/
%{_qt5_includedir}/QtSolutions/QtSingleApplication
%{_qt5_includedir}/QtSolutions/%{name}.h
%{_qt5_libdir}/qt5/mkspecs/features/qtsingleapplication.prf
%{_qt5_libdir}/lib*Qt5Solutions_SingleCoreApplication*.so
%dir %{_qt5_includedir}/QtSolutions/
%{_qt5_includedir}/QtSolutions/QtSingleCoreApplication
%{_qt5_includedir}/QtSolutions/qtsinglecoreapplication.h
%{_qt5_libdir}/qt5/mkspecs/features/qtsinglecoreapplication.prf

### End Qt5 ###
# ----------------------------

%prep
%setup -qnqt-solutions-%{commit0}/%{name}
%patch0 -p0
%patch1 -p0
%patch2 -p1

# use versioned soname
sed -i "s,head,%(echo '%{version}' |sed -r 's,(.*)\..*,\1,'),g" common.pri

mkdir licenses
cp -p %{SOURCE3} licenses

# We already disabled bundling this external library.
# But just to make sure:
rm -rf ../qtlockedfile/
sed -i 's,qtlockedfile\.h,QtSolutions/\0,' src/qtlocalpeer.h
rm src/{QtLocked,qtlocked}*

mkdir qt5
cp -p %{SOURCE1} %{SOURCE2} qt5
sed -i -r 's,-lQt,\05,' qt5/qtsingleapplication.prf
sed -i -r 's,-lQt,\05,' qt5/qtsinglecoreapplication.prf

# additional header needed for Qt5.5
sed -i -r 's,.include,\0 <QtCore/QDataStream>\n\0,' src/qtlocalpeer.h


%build
# Does not use GNU configure
./configure -library
### Qt4 build ###
%{qmake_qt4}
%make

### Qt5 build ###
pushd qt5
%{qmake_qt5} ..
%make

%install
# libraries
mkdir -p %{buildroot}%{_libdir}
cp -a lib/* %{buildroot}%{_libdir}
chmod 755 %{buildroot}%{_libdir}/*.so*

# headers
mkdir -p %{buildroot}%{_qt4_includedir}/QtSolutions
cp -ap \
    src/qtsingleapplication.h \
    src/QtSingleApplication \
    src/qtsinglecoreapplication.h \
    src/QtSingleCoreApplication \
    %{buildroot}%{_qt4_includedir}/QtSolutions

mkdir -p %{buildroot}%{_qt5_includedir}
# symlink is not possible due to split into individual subpackages
cp -ap %{buildroot}%{_qt4_includedir}/QtSolutions %{buildroot}%{_qt5_includedir}

mkdir -p %{buildroot}%{_qt4_datadir}/mkspecs/features %{buildroot}%{_qt5_libdir}/qt5/mkspecs/features
install -p -m644 %{SOURCE1} %{SOURCE2} %{buildroot}%{_qt4_datadir}/mkspecs/features
install -p -m644 qt5/*.prf %{buildroot}%{_qt5_libdir}/qt5/mkspecs/features

%changelog
* Sat Nov 19 2016 adrianomorselli <adrianomorselli> 2.6.1-2uplos2016
- rebuild

* Sun Jun 19 2016 bb <bb> 2.6.1-2pclos2016
- update and add qt5 packages

